<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-row :gutter="20">
          <el-col>
            <el-form-item label="Nombre" prop="name" :error="errors.name">
              <el-input v-model.trim="fields.name" placeholder="Nombre del Producto" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="Categoría" prop="category" :error="errors.category">
              <app-autocomplete
                v-model="fields.category"
                :collection="categories"
                placeholder="Categoría"
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="Marca" prop="brand" :error="errors.brand">
              <app-autocomplete
                v-model="fields.brand"
                :collection="brands"
                placeholder="Marca"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="6">
            <el-form-item label="Precio Minorista" prop="price" :error="errors.price">
              <el-input-number v-model.trim="fields.price" :min="0" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="Precio Mayorista" prop="wholesalerPrice" :error="errors.wholesalerPrice">
              <el-input-number v-model.trim="fields.wholesalerPrice" :min="0" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="Precio Distribuidor" prop="distributorPrice" :error="errors.distributorPrice">
              <el-input-number v-model.trim="fields.distributorPrice" :min="0" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="Precio Sin Cambios" prop="noReturnsPrice" :error="errors.noReturnsPrice">
              <el-input-number v-model.trim="fields.noReturnsPrice" :min="0" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-card>
  </div>
</template>

<script>
import api from "@/feathers";
import BaseForm from "@/common/base-form.mixin";
import AppAutocomplete from "@/common/app-autocomplete";

export default {
  name: "product-form",
  mixins: [BaseForm],
  props: {
    id: { type: String, required: false, default: null }
  },
  components: {
    AppAutocomplete
  },
  data() {
    const rules = {
      name: [
        { required: true, message: "Debe ingresar un nombre", trigger: "blur" }
      ],
      category: [
        {
          required: true,
          message: "Debe ingresar una categoría",
          type: "string",
          trigger: "blur"
        }
      ],
      brand: [
        {
          required: true,
          message: "Debe ingresar una marca",
          type: "string",
          trigger: "blur"
        }
      ],
      price: [
        {
          required: true,
          message: "Debe ingresar un número válido",
          type: "number",
          trigger: "blur"
        }
      ],
      wholesalerPrice: [
        {
          required: false,
          message: "Debe ingresar un número válido",
          type: "number",
          trigger: "blur"
        }
      ],
      distributorPrice: [
        {
          required: false,
          message: "Debe ingresar un número válido",
          type: "number",
          trigger: "blur"
        }
      ],
      noReturnsPrice: [
        {
          required: false,
          message: "Debe ingresar un número válido",
          type: "number",
          trigger: "blur"
        }
      ]
    };
    const { fields, errors } = this.buildForm(rules);

    return {
      title: "",
      rules,
      errors,
      fields,
      brands: [],
      categories: []
    };
  },
  async created() {
    this.service = api.service("products");
    let promises = [this.getCategories(), this.getBrands()];

    if (this.id) {
      this.fields = await this.service.get(this.id);
      this.fields.price = this.fields.price.toFixed(2);
      this.action = "update";
      this.title = `Actualizar ${this.fields.name}`;
    } else {
      this.action = "create";
      this.title = "Nuevo Producto";
    }
    return Promise.all(promises);
  },
  methods: {
    async getCategories() {
      this.categories = await api.service("product-categories").find();
    },
    async getBrands() {
      this.brands = await api.service("product-brands").find();
    }
  }
};
</script>

<style lang="scss">
.el-card {
  &__header {
    margin: 0;
    paddiong: 10px 20px 4px 20px;
    h3 {
      margin: 0;
      padding: 10px 0px;
    }
  }
}
</style>
